This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours

Bug 204948 (wakeup)

Summary: Userspace sucks (wakeups)
Product: [Fedora] Fedora Reporter: David Woodhouse <dwmw2>
Component: distributionAssignee: Jaroslav Škarvada <jskarvad>
Status: CLOSED WORKSFORME QA Contact:
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: amlau, arjan, bnocera, dcantrell, drees76, fedora, gajownik, jskarvad, mark, mattdm, mclasen, mgarski, mozilla_bugs, nsoranzo, pknirsch, rvokal, slamb, tromey, walovaton
Target Milestone: ---Keywords: Tracking
Target Release: ---   
Hardware: All   
OS: Linux   
URL: http://www.energystar.gov/index.cfm?c=revisions.computer_spec
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2014-07-10 11:11:28 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On: 201860, 204725, 204748, 204752, 204850, 204858, 204862, 204906, 204908, 204936, 204946, 204968, 204969, 204990, 205008, 205064, 205068, 205182, 205184, 205449, 205588, 205909, 205910, 210019, 210029, 213042, 213058, 214756, 214760, 218406, 227476, 227487, 227504, 239893, 239945, 240073, 240385, 242377, 242397, 242398, 246341, 248315, 249634, 251534, 251580, 251617, 251725, 252127, 252129, 252140, 252258, 252352, 253445, 254216, 267041, 281001, 313381, 313421, 335551, 335591, 390711, 391571, 394681, 408131, 417321, 426049, 426051, 426968, 427477, 486111, 512616, 521952, 917709    
Bug Blocks: 484668, 191931, 235705    
Attachments:
Description Flags
powertop showing the improvements from Fedora 7 to Fedora 8 Test 1 none

Description David Woodhouse 2006-09-01 12:47:06 EDT
Our userspace sucks. It keeps waking up to poll things it really doesn't need to.
We should strive to be _entirely_ event-driven, as much as possible.

Constant wakeups will screw power consumption -- especially once we have the
kernel timer tick eliminated so we're actually waking the CPU for each userspace
stupidity.
Comment 1 David Woodhouse 2006-09-01 12:50:49 EDT
*** Bug 204949 has been marked as a duplicate of this bug. ***
Comment 2 Arjan van de Ven 2006-12-13 08:31:52 EST
http://www.fenrus.org/cstop.stp

this systemtap script (run with "stap -v cstop.stp") reports the top 20 context
switchers very 10 seconds. With this script you don't need kernel hacks or any
tricks to check your own OS for this type of bug.

(you do need the kernel-debuginfo package installed though)
Comment 3 Bill Nottingham 2007-02-27 18:16:49 EST
This stap script doesn't work with current kernels - even after fixing
HRTIMER_REL -> HRTIMER_MODE_REL in systemtap.
Comment 4 Arjan van de Ven 2007-05-12 20:15:37 EDT
PowerTOP is a useful tool to work on this stuff:

http://www.linuxpowertop.org

Comment 5 Richard Hughes 2007-05-14 04:55:13 EDT
See bug https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=204908 also,
regarding g-p-m and DPMS state checking. I've changed g-p-m 2.18.3 (soon to be
released) to poll every 10s rather than 500ms, although this is just a hack.
Comment 6 William Lovaton 2007-08-13 23:03:32 EDT
Created attachment 161243 [details]
powertop showing the improvements from Fedora 7 to Fedora 8 Test 1

I just updated to rawhide with the latest updates as of today and wanted to
show the improvements made so far in the power consumption area.  The attached
image shows 2 powertop instances, the left one from Fedora 7 and the right one
from Fedora 8 Test 1 both running the same desktop, SELinux disabled (just for
now) and firewall up and running with a Gnome desktop with little tweaks that
differ from the defaults.

Note: I had to disable assistive technologies in F8T1 because it was causing
some wake ups (at-spi-registryd) and making X to wake up too.

Conclusion: F7 did 48.3 wps whilst F8T1 did 20.2 wps, for F7 that was the
lowest mark I ever saw.  F8 sometimes gets to score under 20.  The biggest
improvement being here the mixer_applet thing in the new version of Gnome.

The other ones are already reported but I wonder what is the kernel doing in
that "clocksource_register (clocksource_watchdog)"???  is that fixable?  maybe
it's there because my hardware is a little old: AMD Athlon(TM) XP 2000+

Can anyone spot some other problems from looking at this two screen shots??

Congratulations everyone!.
Comment 7 Alan Jenkins 2008-01-12 09:49:15 EST
I speculated on the clocksource wakeups on the powertop related mailing list.  
<http://www.bughost.org/pipermail/power/2007-October/001080.html>.  I can make 
them go away with no ill effects (disclaimer: only tested on my hardware). 
It's a one-line change in the named function (replace init_timer with 
init_timer_deferrable).  I've not had any response though :-(.
Comment 11 Matthew Miller 2014-07-09 13:37:31 EDT
Looks like all of the bugs against this have been closed. Does userspace no longer suck? :)

In seriousness, should we keep this tracker open for future work, or close it? It's been six and a half years since there was any real activity.
Comment 12 Matthias Clasen 2014-07-10 10:50:00 EDT
Its software, do you need to ask ? It'll suck forever. However, +1 from me for closing this bug.
Comment 13 Matthew Miller 2014-07-10 11:11:28 EDT
(In reply to Matthias Clasen from comment #12)
> Its software, do you need to ask ? It'll suck forever. 

I guess given that fatalism, WORKSFORME is the most fitting resolution. :)